import kernel.ui.WindowManager;
import kernel.ps.ProcessManager;
import kernel.binstore.BinStore;
import kernel.MainTerm;
import lib.HomeContext;

class Startup {
	public static function main() {
		if (MainTerm.instance.isColor()) {
			var main = new HomeContext();

			main.run();
		} else {
			var term = BinStore.instantiate("terminal");
			var pid = ProcessManager.run(term, {});
			var ctx = WindowManager.getContextByPID(pid);
			WindowManager.focusContextToOutput(ctx[0], "main");
		}
	}
}
